.auto-deploy:
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v2"
  dependencies: []

default:
  image: alpine:latest

variables:
  DOCKER_DRIVER: overlay2

stages:
  - test
  - build
  - deploy-prod

test:
  image: cypress/base:14.16.0
  stage: test
  script:
    - cd frontend && yarn && yarn test:e2e
  allow_failure: true

build:
  stage: build
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-build-image:v0.4.0"
  variables:
    DOCKER_TLS_CERTDIR: ""
    WORK_DIR: "."
    IMAGE_SUFFIX: "1337"
  services:
    - docker:19.03.12-dind
  script:
    - |
      if [[ -z "$CI_COMMIT_TAG" ]]; then
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG}-$IMAGE_SUFFIX
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_SHA}
      else
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE}-$IMAGE_SUFFIX
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_TAG}
      fi
    - cd $WORK_DIR && /build/build.sh
  rules:
    - if: '$CI_COMMIT_BRANCH != "cicd-prod" && $CI_COMMIT_BRANCH != "deploy-prod" && $CI_COMMIT_BRANCH != "deploy-stage"'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'

deploy:
  extends: .auto-deploy
  stage: deploy-prod
  variables:
    IMAGE_SUFFIX: "1337"
    ROLLOUT_RESOURCE_TYPE: deployment
  script:
    - |
      if [[ -z "$CI_COMMIT_TAG" ]]; then
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG}-$IMAGE_SUFFIX
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_SHA}
      else
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE}-$IMAGE_SUFFIX
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_TAG}
      fi
    - auto-deploy check_kube_domain
    - auto-deploy download_chart
    - auto-deploy ensure_namespace
    - auto-deploy create_secret
    - auto-deploy deploy
  environment:
    name: "tretton37"
    url: http://$KUBE_INGRESS_BASE_DOMAIN
  rules:
    - if: '$CI_COMMIT_BRANCH != "deploy-prod"'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
